    SUBROUTINE phrase_to_seed(phrase,seed1,seed2)
!**********************************************************************
!     SUBROUTINE PHRTSD( PHRASE, SEED1, SEED2 )
!               PHRase To SeeDs
!                              Function
!     Uses a phrase (character string) to generate two seeds for the RGN
!     random number generator.
!                              Arguments
!     PHRASE --> Phrase to be used for random number generation
!                         CHARACTER*(*) PHRASE
!     SEED1 <-- First seed for RGN generator
!                         INTEGER SEED1
!     SEED2 <-- Second seed for RGN generator
!                         INTEGER SEED2
!                              Note
!     Trailing blanks are eliminated before the seeds are generated.
!     Generated seed values will fall in the range 1..2^30
!     (1..1,073,741,824)
!**********************************************************************
!     JJV added Save statement for variable in Data statement
!     JJV end addition
! .. Implicit None Statement ..
      IMPLICIT NONE
! ..
! .. Parameters ..
      INTEGER, PARAMETER :: twop30 = 1073741824
      CHARACTER (86), PARAMETER :: table = 'abcdefghijklmnopqrstuvwxyz' &
        // 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' // '0123456789' // &
        '!@#$%^&*()_+[];:''"<>?,./'
! ..
! .. Scalar Arguments ..
      INTEGER, INTENT (OUT) :: seed1, seed2
      CHARACTER (*) :: phrase
! ..
! .. Local Scalars ..
      INTEGER :: i, ichr, j, lphr
! ..
! .. Local Arrays ..
      INTEGER, SAVE :: shift(0:4)
      INTEGER :: values(5)
! ..
! .. Intrinsic Functions ..
      INTRINSIC INDEX, LEN_TRIM, MOD
! ..
! .. Data Statements ..
      DATA shift/1, 64, 4096, 262144, 16777216/
! ..
! .. Executable Statements ..

      seed1 = 1234567890
      seed2 = 123456789
      lphr = LEN_TRIM(phrase)
      IF (lphr<1) RETURN
      DO i = 1, lphr
        ichr = MOD(INDEX(table,phrase(i:i)),64)
        IF (ichr==0) ichr = 63
        DO j = 1, 5
          values(j) = ichr - j
          IF (values(j)>=1) CYCLE
          values(j) = values(j) + 63
        END DO
        DO j = 1, 5
          seed1 = MOD(seed1+shift(j-1)*values(j),twop30)
          seed2 = MOD(seed2+shift(j-1)*values(6-j),twop30)
        END DO
      END DO
      RETURN

    END SUBROUTINE phrase_to_seed
