    MODULE sppcr_aux_mod
! .. Default Accessibility ..
      PUBLIC
! ..
! .. Private Statements ..
      PRIVATE :: dpkind
! ..
! .. Parameters ..
      INTEGER, PARAMETER :: dpkind = KIND(0.0D0)
      REAL (dpkind), PARAMETER :: one = 1.0_dpkind
      REAL (dpkind), PARAMETER :: two = 2.0_dpkind
! ..
! .. Intrinsic Functions ..
      INTRINSIC KIND
! ..
    CONTAINS

!*********************************************************************

      ELEMENTAL FUNCTION arcsin(p)
! .. Function Return Value ..
        REAL (dpkind) :: arcsin
! ..
! .. Scalar Arguments ..
        REAL (dpkind), INTENT (IN) :: p
! ..
! .. Intrinsic Functions ..
        INTRINSIC ASIN, SQRT
! ..
        arcsin = two*ASIN(SQRT(p))

        RETURN

      END FUNCTION arcsin

!*********************************************************************

      ELEMENTAL FUNCTION asy_var_arcsin(p,var_p)
!!! Asymptotic Variance of the arcsin transform of p
! .. Function Return Value ..
        REAL (dpkind) :: asy_var_arcsin
! ..
! .. Scalar Arguments ..
        REAL (dpkind), INTENT (IN) :: p, var_p
! ..
! .. Parameters ..
        REAL (dpkind), PARAMETER :: tiny = 1.0E-10_dpkind
! ..
! .. Local Scalars ..
        REAL (dpkind) :: local_p
! ..
! .. Intrinsic Functions ..
        INTRINSIC MAX, MIN
! ..
        local_p = MAX(p,tiny)

        local_p = MIN(p,one-tiny)

        asy_var_arcsin = var_p/(local_p*(one-local_p))

        RETURN

      END FUNCTION asy_var_arcsin

!*********************************************************************

      ELEMENTAL FUNCTION inv_arcsin(trans)
! .. Function Return Value ..
        REAL (dpkind) :: inv_arcsin
! ..
! .. Scalar Arguments ..
        REAL (dpkind), INTENT (IN) :: trans
! ..
! .. Intrinsic Functions ..
        INTRINSIC SIN
! ..
        inv_arcsin = (SIN(trans/two))**2

        RETURN

      END FUNCTION inv_arcsin

!*********************************************************************

    END MODULE sppcr_aux_mod
