#include "randombinomial.h"
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

unsigned int randrot();


double random_binomial(double n, double pp)
{
	double al, alv, amaxp, f, f1, f2, ffm, u, v, w, w2, x, x1, x2, ynorm, z, z2;
	static double c, fm, g, p, p1, p2, p3, p4, psave, q, qn, r, xl, xll, xlr, xm, xnp, xnpq, xr;
    int i, ix, ix1, k, mp;
    static int m, nsave;
	nsave=-214748365;
	psave=-pow(10,37);
	if(pp==psave)
	{
		if(n!=nsave)
			goto lbl10;
		if(xnp-30<0)	// this is personally too risky for my taste
			goto lbl50;
		goto lbl20;
	}
	if(pp<0 || pp>1)
	{
		printf("pp is %s\n",pp>1?"greater than 1":"less than 0");
		exit(1);
	}
	psave = pp;
	p=psave<1-psave?psave:1-psave;
	q=1-p;
lbl10:
	if(n<0)
	{
		printf("N<0... aborting\n");
		exit(1);
	}
	xnp=n*p;
	nsave=n;
	if(xnp<30)
	{
		qn=pow(q,n);	// lbl 40
		r=p/q;
		g=r*(n+1);
lbl50:
		ix=0;			
		f=qn;
		u=random_standard_uniform();
lbl60:
		if(u<f)			// lbl 60
		{
			if(psave>.5)	// lbl 70
				ix=n-ix;	
			return ix;
		}
		if(ix>110)
			goto lbl50;
		u=u-f;
		ix=ix+1;
		f=f*(g/ix-r);
		goto lbl60;
	}
	fm=m=ffm=xnp+p;
	xnpq=xnp*q;
	p1=(int)(2.195*sqrt(xnpq)-4.6*q) + .5;
	xm=fm+.5;
	xl=xm-p1;
	xr=xm+p1;
	c=.134 + 20.5/(15.3+fm);
	al=(ffm-xl)/(xr*q);
	xll = al*(1+.5*al);		// consider simplifying for speed boost
	al=(xr-ffm)/(xr*q);
	xlr=al*(1.0+.5*al);
	p2=p1*(1+2*c);
	p3=p2 + c/xll;
	p4=p3 + c/xlr; 

lbl20:
	u=random_standard_uniform()*p4;					// lbl 20
	v=random_standard_uniform();
	if(u<=p1)			// triangular region
	{
		ix=xm-p1*v + u;
		if(psave>.5)	// lbl 70
			ix=n-ix;	
		return ix;
	}
	if(u<=p2)			// parallelogram region
	{
		x=xl+(u-p1)/c;
		v=v*c + 1 - fabs(xm-x)/p1;
		if(v>1 || v<=0)
			goto lbl20;
		else
		{
			if(u<=p3)		// left tail
			{
				ix=xl+log(v)/xll;
				if(ix<0)
					goto lbl20;
				v*=(u-p2)*xll;
			}
			else			// right tail
			{
				ix=xr-log(v)/xlr;
				if(ix>n)
					goto lbl20;
				v*=(u-p3)*xlr;
			}
		}
	}
	k=fabs(ix-m);
	if(k<=20 || k>=xnpq/2.0-1)
	{
		f=1;
		r=p/q;
		g=(n+1)*r;
		if(m-ix<=0)
		{
			if(m-ix==0)
			goto lbl30;
			mp=m+1;
			for(i=mp;i<ix;i++)
				f=f*(g/i - r);
			goto lbl30;
		}
		ix1=ix+1;
		for(i=ix;i<m;i++)
			f=f/(g/i-r);
lbl30:
		if(v-f>0)
			goto lbl20;
		if(psave>.5)	// lbl 70
			ix=n-ix;	
		return ix;
	}
	amaxp=(k/xnpq)*((k*(k/3 + .625) + .1666666)/xnpq+.5);
	ynorm=-k*k/(2*xnpq);
	alv=log(v);
	if(alv<ynorm-amaxp)
	{
		if(psave>.5)	// lbl 70
			ix=n-ix;	
		return ix;
	}
	if(alv>ynorm+amaxp)
		goto lbl20;
	
	x1=ix+1;
	f1=fm+1;
	z=n+1-fm;
	w=n-ix+1;
	z2=z*z;
	x2=x1*x1;
	f2=f1*f1;
	w2=w*w;
	if(alv-(xm*log(f1/x1)+(n-m+0.5)*log(z/w)+(ix-m)*log(w*p/(x1*q))+(13860.-(462.-(132.-(99.-140./f2)/f2)/f2)/f2)/f1/166320.+(13860.-(462.-(132.-(99.-140./z2)/z2)/z2)/z2)/z/166320.+(13860.-(462.-(132.-(99.-140./x2)/x2)/x2)/x2)/x1/166320.+(13860.-(462.-(132.-(99.-140./w2)/w2)/w2)/w2)/w/166320.)>0.)
		  goto lbl20;
	if(psave>.5)	// lbl 70
		ix=n-ix;	
	return ix;
}

double random_standard_uniform()
{
	unsigned int bob=randrot()%2147483562;
	bob++;
	return bob*4.656613057*pow(10,-10);
}